searchData={"content_type":"text/markdown","items":[{"doc":"An update action to call after the last attempt has failed. See the getting started guide for more.","ref":"AshOban.html#oban-triggers-trigger-on_error","title":"AshOban.oban.triggers.trigger.on_error","type":"DSL"},{"doc":"The filter expression to determine if something should be triggered","ref":"AshOban.html#oban-triggers-trigger-where","title":"AshOban.oban.triggers.trigger.where","type":"DSL"},{"doc":"The action to be triggered. Defaults to the identifier of the resource plus the name of the trigger","ref":"AshOban.html#oban-triggers-trigger-action","title":"AshOban.oban.triggers.trigger.action","type":"DSL"},{"doc":"The read action to use when fetching the individual records for the trigger. Defaults to `read_action`. If you customize this, ensure your action handles scenarios where the trigger is no longer relevant.\n","ref":"AshOban.html#oban-triggers-trigger-worker_read_action","title":"AshOban.oban.triggers.trigger.worker_read_action","type":"DSL"},{"doc":"The read action to use when querying records. Defaults to the primary read. This action *must* support keyset pagination.\n","ref":"AshOban.html#oban-triggers-trigger-read_action","title":"AshOban.oban.triggers.trigger.read_action","type":"DSL"},{"doc":"Describes the state of the cron job. See the getting started guide for more information. The most important thing is that you *do not remove a trigger from a resource if you are using oban pro*.\n","ref":"AshOban.html#oban-triggers-trigger-state","title":"AshOban.oban.triggers.trigger.state","type":"DSL"},{"doc":"Takes a record, and returns metadata to be given to the update action as an argument called `metadata`.\n","ref":"AshOban.html#oban-triggers-trigger-read_metadata","title":"AshOban.oban.triggers.trigger.read_metadata","type":"DSL"},{"doc":"How many times to attempt the job. After all attempts have been exhausted, the scheduler may just reschedule it. Use the `on_error` action to update the record to make the scheduler no longer apply.\n","ref":"AshOban.html#oban-triggers-trigger-max_attempts","title":"AshOban.oban.triggers.trigger.max_attempts","type":"DSL"},{"doc":"How many times to attempt scheduling of the triggered action.","ref":"AshOban.html#oban-triggers-trigger-max_scheduler_attempts","title":"AshOban.oban.triggers.trigger.max_scheduler_attempts","type":"DSL"},{"doc":"A number from 0 to 3, where 0 is the highest priority and 3 is the lowest.","ref":"AshOban.html#oban-triggers-trigger-scheduler_priority","title":"AshOban.oban.triggers.trigger.scheduler_priority","type":"DSL"},{"doc":"A number from 0 to 3, where 0 is the highest priority and 3 is the lowest.","ref":"AshOban.html#oban-triggers-trigger-worker_priority","title":"AshOban.oban.triggers.trigger.worker_priority","type":"DSL"},{"doc":"If set, any given run of the scheduler will only ever schedule this many items maximum","ref":"AshOban.html#oban-triggers-trigger-record_limit","title":"AshOban.oban.triggers.trigger.record_limit","type":"DSL"},{"doc":"The queue to place the worker job in. The trigger name is used by default.","ref":"AshOban.html#oban-triggers-trigger-queue","title":"AshOban.oban.triggers.trigger.queue","type":"DSL"},{"doc":"The batch size to pass when streaming records from using `c:Ash.Api.stream!/2`. No batch size is passed if none is provided here, so the default is used.","ref":"AshOban.html#oban-triggers-trigger-stream_batch_size","title":"AshOban.oban.triggers.trigger.stream_batch_size","type":"DSL"},{"doc":"A crontab configuration for when the job should run. Defaults to once per minute (\"* * * * *\"). Use `false` to disable the scheduler entirely.\n","ref":"AshOban.html#oban-triggers-trigger-scheduler_cron","title":"AshOban.oban.triggers.trigger.scheduler_cron","type":"DSL"},{"doc":"The queue to place the scheduler job in. The same queue as job is used by default (but with a priority of 1 so schedulers run first).","ref":"AshOban.html#oban-triggers-trigger-scheduler_queue","title":"AshOban.oban.triggers.trigger.scheduler_queue","type":"DSL"},{"doc":"A unique identifier for this trigger.","ref":"AshOban.html#oban-triggers-trigger-name","title":"AshOban.oban.triggers.trigger.name","type":"DSL"},{"doc":"","ref":"AshOban.html#oban-triggers-trigger","title":"AshOban.oban.triggers.trigger","type":"DSL"},{"doc":"","ref":"AshOban.html#oban-triggers","title":"AshOban.oban.triggers","type":"DSL"},{"doc":"The Api module to use when calling actions on this resource","ref":"AshOban.html#oban-api","title":"AshOban.oban.api","type":"DSL"},{"doc":"","ref":"AshOban.html#oban","title":"AshOban.oban","type":"DSL"},{"doc":"Tools for working with AshOban triggers.","ref":"AshOban.html","title":"AshOban","type":"module"},{"doc":"Alters your oban configuration to include the required AshOban configuration.","ref":"AshOban.html#config/2","title":"AshOban.config/2","type":"function"},{"doc":"","ref":"AshOban.html#run_trigger/3","title":"AshOban.run_trigger/3","type":"function"},{"doc":"","ref":"AshOban.html#schedule/2","title":"AshOban.schedule/2","type":"function"},{"doc":"Builtin changes for `AshOban`","ref":"AshOban.Changes.BuiltinChanges.html","title":"AshOban.Changes.BuiltinChanges","type":"module"},{"doc":"","ref":"AshOban.Changes.BuiltinChanges.html#run_oban_trigger/2","title":"AshOban.Changes.BuiltinChanges.run_oban_trigger/2","type":"function"},{"doc":"Runs an oban trigger by name.","ref":"AshOban.Changes.RunObanTrigger.html","title":"AshOban.Changes.RunObanTrigger","type":"module"},{"doc":"","ref":"AshOban.Changes.RunObanTrigger.html#atomic/2","title":"AshOban.Changes.RunObanTrigger.atomic/2","type":"function"},{"doc":"","ref":"AshOban.Changes.RunObanTrigger.html#change/3","title":"AshOban.Changes.RunObanTrigger.change/3","type":"function"},{"doc":"","ref":"AshOban.Changes.RunObanTrigger.html#init/1","title":"AshOban.Changes.RunObanTrigger.init/1","type":"function"},{"doc":"This check is true if the context `private.ash_oban?` is set to true.\n\nThis context will only ever be set in code that is called internally by\n`ash_oban`, allowing you to create a bypass in your policies on your\nuser/user_token resources.\n\n```elixir\npolicies do\n  bypass AshObanInteraction do\n    authorize_if always()\n  end\nend\n```","ref":"AshOban.Checks.AshObanInteraction.html","title":"AshOban.Checks.AshObanInteraction","type":"module"},{"doc":"","ref":"AshOban.Checks.AshObanInteraction.html#strict_check/3","title":"AshOban.Checks.AshObanInteraction.strict_check/3","type":"function"},{"doc":"","ref":"AshOban.Checks.AshObanInteraction.html#type/0","title":"AshOban.Checks.AshObanInteraction.type/0","type":"function"},{"doc":"Introspection for AshOban","ref":"AshOban.Info.html","title":"AshOban.Info","type":"module"},{"doc":"The Api module to use when calling actions on this resource","ref":"AshOban.Info.html#oban_api/1","title":"AshOban.Info.oban_api/1","type":"function"},{"doc":"The Api module to use when calling actions on this resource","ref":"AshOban.Info.html#oban_api!/1","title":"AshOban.Info.oban_api!/1","type":"function"},{"doc":"oban DSL options\n\nReturns a map containing the and any configured or default values.","ref":"AshOban.Info.html#oban_options/1","title":"AshOban.Info.oban_options/1","type":"function"},{"doc":"","ref":"AshOban.Info.html#oban_trigger/2","title":"AshOban.Info.oban_trigger/2","type":"function"},{"doc":"oban.triggers DSL entities","ref":"AshOban.Info.html#oban_triggers/1","title":"AshOban.Info.oban_triggers/1","type":"function"},{"doc":"","ref":"AshOban.Info.html#pro?/0","title":"AshOban.Info.pro?/0","type":"function"},{"doc":"A configured trigger.","ref":"AshOban.Trigger.html","title":"AshOban.Trigger","type":"module"},{"doc":"","ref":"AshOban.Trigger.html#transform/1","title":"AshOban.Trigger.transform/1","type":"function"},{"doc":"","ref":"AshOban.Trigger.html#t:t/0","title":"AshOban.Trigger.t/0","type":"type"},{"doc":"Helpers for testing ash_oban triggers","ref":"AshOban.Test.html","title":"AshOban.Test","type":"module"},{"doc":"","ref":"AshOban.Test.html#schedule_and_run_triggers/1","title":"AshOban.Test.schedule_and_run_triggers/1","type":"function"},{"doc":"# Get Started With Ash Oban\n\nAshOban will likely grow to provide many more oban-related features, but for now the primary focus is on \"triggers\".\n\nA trigger describes an action that is run periodically.","ref":"get-started-with-ash-oban.html","title":"Get Started With Ash Oban","type":"extras"},{"doc":"If you haven't already, read the [Ash Getting Started Guide](https://hexdocs.pm/ash/get-started.html), and familiarize yourself with Ash and Ash resources.","ref":"get-started-with-ash-oban.html#get-familiar-with-ash-resources","title":"Get familiar with Ash resources - Get Started With Ash Oban","type":"extras"},{"doc":"```elixir\ndef deps()\n  [\n    ...\n    {:ash_oban, \"~> 0.1.8\"}\n  ]\nend\n```","ref":"get-started-with-ash-oban.html#bring-in-the-ash_oban-dependency","title":"Bring in the ash_oban dependency - Get Started With Ash Oban","type":"extras"},{"doc":"First, follow the oban setup guide.\n\n#","ref":"get-started-with-ash-oban.html#setup","title":"Setup - Get Started With Ash Oban","type":"extras"},{"doc":"If you are using Oban Pro, set the following configuration:\n\n```elixir\nconfig :ash_oban, :pro?, true\n```\n\nOban Pro lives in a separate hex repository, and therefore we, unfortunately, cannot have an explicit version dependency on it.\nWhat this means is that any version you use in hex will technically be accepted, and if you don't have the oban pro package installed\nand you use the above configuration, you will get compile time errors/warnings.\n\n#","ref":"get-started-with-ash-oban.html#oban-pro","title":"Oban Pro - Get Started With Ash Oban","type":"extras"},{"doc":"Next, allow AshOban to alter your configuration\n\n```elixir\n# in your application\n{Oban, AshOban.config([YourApi, YourOtherApi], your_oban_config)}\n```","ref":"get-started-with-ash-oban.html#setting-up-ashoban","title":"Setting up AshOban - Get Started With Ash Oban","type":"extras"},{"doc":"Finally, configure your triggers in your resources.\n\nAdd the `AshOban` extension:\n\n```elixir\nuse Ash.Resource, extensions: [AshOban]\n```\n\nFor example:\n\n```elixir\noban do\n  api YourApi\n\n  triggers do\n    # add a trigger called `:process`\n    trigger :process do\n      # this trigger calls the `process` action\n      action :process\n      # for any record that has `processed != true`\n      where expr(processed != true)\n      # checking for matches every minute\n      scheduler_cron \"* * * * *\"\n      on_error :errored\n    end\n  end\nend\n```\n\nSee the DSL documentation for more: `AshOban`","ref":"get-started-with-ash-oban.html#usage","title":"Usage - Get Started With Ash Oban","type":"extras"},{"doc":"Error handling is done by adding an `on_error` to your trigger. This is an update action that will get the error as an argument called `:error`. The error will be an Ash error class.  These error classes can contain many kinds of errors, so you will need to figure out handling specific errors on your own.  Be sure to add the `:error` argument to the action if you want to receive the error.\n\nThis is *not* foolproof. You want to be sure that your `on_error` action is as simple as possible, because if an exception is raised during the `on_error` action, the oban job will fail. If you are relying on your `on_error` logic to alter the resource to make it no longer apply to a trigger, consider making your action do *only that*. Then you can add another trigger watching for things in an errored state to do more rich error handling behavior.","ref":"get-started-with-ash-oban.html#handling-errors","title":"Handling Errors - Get Started With Ash Oban","type":"extras"},{"doc":"To remove or disable triggers, *do not just remove them from your resource*. Due to the way that oban implements cron jobs, if you just remove them from your resource, the cron will attempt to continue scheduling jobs. Instead, set `paused true` or `delete true` on the trigger. See the oban docs for more: https://getoban.pro/docs/pro/0.14.1/Oban.Pro.Plugins.DynamicCron.html#module-using-and-configuring","ref":"get-started-with-ash-oban.html#changing-triggers","title":"Changing Triggers - Get Started With Ash Oban","type":"extras"},{"doc":"AshOban adds two new transaction reasons, as it uses explicit transactions to ensure that each triggered record is properly locked and executed in serially.\n\n```elixir\n%{\n  type: :ash_oban_trigger,\n  metadata: %{\n    resource: Resource,\n    trigger: :trigger_name,\n    primary_key: %{primary_key_fields: value}\n  }\n}\n```\nand\n```elixir\n%{\n  type: :ash_oban_trigger_error,\n  metadata: %{\n    resource: Resource\n    trigger: :trigger_name,\n    primary_key: %{primary_key_fields: value},\n    error:  \n  }\n}\n```","ref":"get-started-with-ash-oban.html#transactions","title":"Transactions - Get Started With Ash Oban","type":"extras"},{"doc":"# DSL: AshOban\n\nTools for working with AshOban triggers.","ref":"dsl-ashoban.html","title":"DSL: AshOban","type":"extras"},{"doc":"#","ref":"dsl-ashoban.html#oban","title":"oban - DSL: AshOban","type":"extras"},{"doc":"* [triggers](#oban-triggers)\n   * trigger\n\n\n#","ref":"dsl-ashoban.html#nested-dsls","title":"Nested DSLs - DSL: AshOban","type":"extras"},{"doc":"```\noban do\n  api AshOban.Test.Api\n\n  triggers do\n    trigger :process do\n      action :process\n      where expr(processed != true)\n      worker_read_action(:read)\n    end\n  end\nend\n\n```\n\n\n\n\n#","ref":"dsl-ashoban.html#examples","title":"Examples - DSL: AshOban","type":"extras"},{"doc":"| Name | Type | Default | Docs |\n| ---  | ---  | ---     | ---  |\n| `api`* | `module` |  | The Api module to use when calling actions on this resource |","ref":"dsl-ashoban.html#options","title":"Options - DSL: AshOban","type":"extras"},{"doc":"#","ref":"dsl-ashoban.html#oban-triggers","title":"oban.triggers - DSL: AshOban","type":"extras"},{"doc":"* [trigger](#oban-triggers-trigger)\n\n\n#","ref":"dsl-ashoban.html#nested-dsls","title":"Nested DSLs - DSL: AshOban","type":"extras"},{"doc":"```\ntriggers do\n  trigger :process do\n    action :process\n    where expr(processed != true)\n    worker_read_action(:read)\n  end\nend\n\n```","ref":"dsl-ashoban.html#examples","title":"Examples - DSL: AshOban","type":"extras"},{"doc":"```elixir\ntrigger name\n```\n\n\n\n\n\n\n#","ref":"dsl-ashoban.html#oban-triggers-trigger","title":"oban.triggers.trigger - DSL: AshOban","type":"extras"},{"doc":"```\ntrigger :process do\n  action :process\n  where expr(processed != true)\n  worker_read_action(:read)\nend\n\n```\n\n\n\n#","ref":"dsl-ashoban.html#examples","title":"Examples - DSL: AshOban","type":"extras"},{"doc":"| Name | Type | Default | Docs |\n| ---  | ---  | ---     | ---  |\n| `name` | `atom` |  | A unique identifier for this trigger. |\n#","ref":"dsl-ashoban.html#arguments","title":"Arguments - DSL: AshOban","type":"extras"},{"doc":"| Name | Type | Default | Docs |\n| ---  | ---  | ---     | ---  |\n| `action`* | `atom` |  | The action to be triggered. Defaults to the identifier of the resource plus the name of the trigger |\n| `scheduler_queue` | `atom` |  | The queue to place the scheduler job in. The same queue as job is used by default (but with a priority of 1 so schedulers run first). |\n| `scheduler_cron` | `String.t \\| false` | \"* * * * *\" | A crontab configuration for when the job should run. Defaults to once per minute (\"* * * * *\"). Use `false` to disable the scheduler entirely. |\n| `stream_batch_size` | `pos_integer` |  | The batch size to pass when streaming records from using `c:Ash.Api.stream!/2`. No batch size is passed if none is provided here, so the default is used. |\n| `queue` | `atom` |  | The queue to place the worker job in. The trigger name is used by default. |\n| `record_limit` | `pos_integer` |  | If set, any given run of the scheduler will only ever schedule this many items maximum |\n| `worker_priority` | `non_neg_integer` | 2 | A number from 0 to 3, where 0 is the highest priority and 3 is the lowest. |\n| `scheduler_priority` | `non_neg_integer` | 3 | A number from 0 to 3, where 0 is the highest priority and 3 is the lowest. |\n| `max_scheduler_attempts` | `pos_integer` | 1 | How many times to attempt scheduling of the triggered action. |\n| `max_attempts` | `pos_integer` | 1 | How many times to attempt the job. After all attempts have been exhausted, the scheduler may just reschedule it. Use the `on_error` action to update the record to make the scheduler no longer apply. |\n| `read_metadata` | `(any -> any)` |  | Takes a record, and returns metadata to be given to the update action as an argument called `metadata`. |\n| `state` | `:active \\| :paused \\| :deleted` | :active | Describes the state of the cron job. See the getting started guide for more information. The most important thing is that you *do not remove a trigger from a resource if you are using oban pro*. |\n| `read_action` | `atom` |  | The read action to use when querying records. Defaults to the primary read. This action *must* support keyset pagination. |\n| `worker_read_action` | `atom` |  | The read action to use when fetching the individual records for the trigger. Defaults to `read_action`. If you customize this, ensure your action handles scenarios where the trigger is no longer relevant. |\n| `where` | ``any`` |  | The filter expression to determine if something should be triggered |\n| `on_error` | `atom` |  | An update action to call after the last attempt has failed. See the getting started guide for more. |\n\n\n\n\n\n#","ref":"dsl-ashoban.html#options","title":"Options - DSL: AshOban","type":"extras"},{"doc":"Target: `AshOban.Trigger`","ref":"dsl-ashoban.html#introspection","title":"Introspection - DSL: AshOban","type":"extras"}]}